-- ================================================================================
--   Database name : COMISSARIA
--   Created on    : 19/04/2005
--   Programadora  : Leonardo Monteiro
-- ================================================================================
--   @C:\Win_Prj\Sql\End_Conv\Oracle\1770_COCSTPO_IMPORTA_RECEITA.sql
-- ================================================================================
CREATE OR REPLACE PROCEDURE IMPORTA_RECEITA(
P_IDTIPIMP       IN VARCHAR2, /* '1' - Sobrepor, 2 - Acrescentar */
P_CDPRODUTO_ORI  IN ESPEPROD.CDPRODUTO %TYPE,
P_CDESPEPROD_ORI IN ESPEPROD.CDESPEPROD%TYPE,
P_CDPRODUTO_DES  IN ESPEPROD.CDPRODUTO %TYPE,
P_CDESPEPROD_DES IN ESPEPROD.CDESPEPROD%TYPE
) AS
BEGIN
--raise_application_error(-20502,'x',false);
   IF P_IDTIPIMP = '1' THEN /*Sobrepor*/
      /* Limpa a composio do produto de destino */
      DELETE FROM DOCUPROD
      WHERE (CDPRODUTO  = P_CDPRODUTO_DES ) AND
            (CDESPEPROD = P_CDESPEPROD_DES);

      DELETE FROM COMPPROD
      WHERE (CDPRODUTO  = P_CDPRODUTO_DES ) AND
            (CDESPEPROD = P_CDESPEPROD_DES);

      DELETE FROM TCOMPPRO
      WHERE (CDPRODUTO  = P_CDPRODUTO_DES ) AND
            (CDESPEPROD = P_CDESPEPROD_DES);
      /* *** */

      /* Insere a composio da recieta */
      /*SELECT LPAD(TO_CHAR(NVL(MAX(CDESPEPROD),'0')+1),10,'0')
      INTO V_CDESPEPROD_DES
      FROM ESPEPROD
      WHERE (CDPRODUTO = P_CDPRODUTO_DES);*/

      INSERT INTO TCOMPPRO
      (CDPRODUTO,CDESPEPROD,CDTIPOCOMP,QTPRODTCOMP,IDTCOMPPROC)
      SELECT P_CDPRODUTO_DES,P_CDESPEPROD_DES,CDTIPOCOMP,QTPRODTCOMP,IDTCOMPPROC
      FROM TCOMPPRO
      WHERE (CDPRODUTO  = P_CDPRODUTO_ORI ) AND
            (CDESPEPROD = P_CDESPEPROD_ORI);

      INSERT INTO COMPPROD
      (CDPRODUTO,CDESPEPROD,CDTIPOCOMP,CDPRODINSUMO,
       IDUTAPROVREQ,QTINSUMO,CDTIPOINSU,SGUNIDADE,
       IDSEMIACCOMP,IDUTILOTEPR,CDPRODUTOAUX,CDESPPRODAUX,
       NRORDCOMP,TXCOMITCOMP,IDIMPCOMPDEL,VRLOADCOMP,
       DSLOADCOMP,QTBRUTINSPRO,VRPRENDINSPR)
      SELECT P_CDPRODUTO_DES,P_CDESPEPROD_DES,CDTIPOCOMP,CDPRODINSUMO,
             IDUTAPROVREQ,QTINSUMO,CDTIPOINSU,SGUNIDADE,
             IDSEMIACCOMP,IDUTILOTEPR,CDPRODUTOAUX,CDESPPRODAUX,
             NRORDCOMP,TXCOMITCOMP,IDIMPCOMPDEL,VRLOADCOMP,
             DSLOADCOMP,QTBRUTINSPRO,VRPRENDINSPR
      FROM COMPPROD
      WHERE (CDPRODUTO  = P_CDPRODUTO_ORI ) AND
            (CDESPEPROD = P_CDESPEPROD_ORI);

      INSERT INTO DOCUPROD
      (CDPRODUTO,CDESPEPROD,CDTIPODOCU,/*DSDOCUPROD,*/DSDIRDOCPROD,IDLOCDOCPROD)
      SELECT P_CDPRODUTO_DES,P_CDESPEPROD_DES,CDTIPODOCU,/*DSDOCUPROD,*/DSDIRDOCPROD,IDLOCDOCPROD
      FROM DOCUPROD
      WHERE (CDPRODUTO  = P_CDPRODUTO_ORI ) AND
            (CDESPEPROD = P_CDESPEPROD_ORI);

      FOR C_DOC IN(SELECT CDTIPODOCU,DSDOCUPROD
                   FROM DOCUPROD
                   WHERE (CDPRODUTO  = P_CDPRODUTO_ORI ) AND
                         (CDESPEPROD = P_CDESPEPROD_ORI)) LOOP
   		UPDATE DOCUPROD
         SET DSDOCUPROD = C_DOC.DSDOCUPROD
         WHERE (CDPRODUTO  = P_CDPRODUTO_DES ) AND
               (CDESPEPROD = P_CDESPEPROD_DES) AND
               (CDTIPODOCU = C_DOC.CDTIPODOCU);
      END LOOP;
      /* *** */
      
   ELSIF P_IDTIPIMP = '2' THEN /*Acrescentar*/
   
      INSERT INTO TCOMPPRO
      (CDPRODUTO,CDESPEPROD,CDTIPOCOMP,QTPRODTCOMP,IDTCOMPPROC)
      SELECT P_CDPRODUTO_DES,P_CDESPEPROD_DES,CDTIPOCOMP,QTPRODTCOMP,IDTCOMPPROC
      FROM TCOMPPRO TC
      WHERE (CDPRODUTO  = P_CDPRODUTO_ORI ) AND
            (CDESPEPROD = P_CDESPEPROD_ORI) AND
            (NOT EXISTS(SELECT CDPRODUTO,CDESPEPROD,CDTIPOCOMP
                        FROM TCOMPPRO
                        WHERE (CDPRODUTO  = P_CDPRODUTO_DES ) AND
                              (CDESPEPROD = P_CDESPEPROD_DES) AND
                              (CDTIPOCOMP = TC.CDTIPOCOMP   )));

      INSERT INTO COMPPROD
      (CDPRODUTO,CDESPEPROD,CDTIPOCOMP,CDPRODINSUMO,
       IDUTAPROVREQ,QTINSUMO,CDTIPOINSU,SGUNIDADE,
       IDSEMIACCOMP,IDUTILOTEPR,CDPRODUTOAUX,CDESPPRODAUX,
       NRORDCOMP,TXCOMITCOMP,IDIMPCOMPDEL,VRLOADCOMP,
       DSLOADCOMP,QTBRUTINSPRO,VRPRENDINSPR)
      SELECT P_CDPRODUTO_DES,P_CDESPEPROD_DES,CDTIPOCOMP,CDPRODINSUMO,
             IDUTAPROVREQ,QTINSUMO,CDTIPOINSU,SGUNIDADE,
             IDSEMIACCOMP,IDUTILOTEPR,CDPRODUTOAUX,CDESPPRODAUX,
             NRORDCOMP,TXCOMITCOMP,IDIMPCOMPDEL,VRLOADCOMP,
             DSLOADCOMP,QTBRUTINSPRO,VRPRENDINSPR
      FROM COMPPROD CP
      WHERE (CDPRODUTO  = P_CDPRODUTO_ORI ) AND
            (CDESPEPROD = P_CDESPEPROD_ORI) AND
            (NOT EXISTS(SELECT CDPRODUTO,CDESPEPROD,CDTIPOCOMP,CDPRODINSUMO
                        FROM COMPPROD
                        WHERE (CDPRODUTO    = P_CDPRODUTO_DES ) AND
                              (CDESPEPROD   = P_CDESPEPROD_DES) AND
                              (CDTIPOCOMP   = CP.CDTIPOCOMP   ) AND
                              (CDPRODINSUMO = CP.CDPRODINSUMO )));

      INSERT INTO DOCUPROD
      (CDPRODUTO,CDESPEPROD,CDTIPODOCU,/*DSDOCUPROD,*/DSDIRDOCPROD,IDLOCDOCPROD)
      SELECT P_CDPRODUTO_DES,P_CDESPEPROD_DES,CDTIPODOCU,/*DSDOCUPROD,*/DSDIRDOCPROD,IDLOCDOCPROD
      FROM DOCUPROD DP
      WHERE (CDPRODUTO  = P_CDPRODUTO_ORI ) AND
            (CDESPEPROD = P_CDESPEPROD_ORI) AND
            (NOT EXISTS(SELECT CDPRODUTO,CDESPEPROD,CDTIPODOCU
                        FROM DOCUPROD
                        WHERE (CDPRODUTO  = P_CDPRODUTO_DES ) AND
                              (CDESPEPROD = P_CDESPEPROD_DES) AND
                              (CDTIPODOCU = DP.CDTIPODOCU   )));

      FOR C_DOC IN(SELECT CDTIPODOCU,DSDOCUPROD
                   FROM DOCUPROD
                   WHERE (CDPRODUTO  = P_CDPRODUTO_ORI ) AND
                         (CDESPEPROD = P_CDESPEPROD_ORI)) LOOP
   		UPDATE DOCUPROD
         SET DSDOCUPROD = C_DOC.DSDOCUPROD
         WHERE (CDPRODUTO  = P_CDPRODUTO_DES ) AND
               (CDESPEPROD = P_CDESPEPROD_DES) AND
               (CDTIPODOCU = C_DOC.CDTIPODOCU);
      END LOOP;
   END IF;
END;
/

