/* Sistemas Integrados TEKNISA

Nome: 7821_PLASTPs - EXPORTA_CONSUMO.SQL

Descrio:
Procedimento para exportao no consumo das filial agregadas do Sistema PME

Criao:
28/04/2007 - Felipe Amaral Gurgel
*/


IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
           WHERE
           O.NAME = 'EXPORTA_CONSUMO' AND
	   TYPE = 'P' 		      AND
	   U.UID = O.UID              AND
	   U.NAME = USER)

   DROP PROCEDURE EXPORTA_CONSUMO
GO

CREATE PROCEDURE EXPORTA_CONSUMO
   @P_CDFILICENTGRAVA VARCHAR(4),
   @P_IDTIPOCONSGRAVA VARCHAR(1),
   @P_DTCONSSERVGRAVA DATETIME,
   @P_CDFILICENTORIG  VARCHAR(4),
   @P_CDFILIORIG      VARCHAR(4),
   @P_CDSERVORIG      VARCHAR(5),
   @P_IDQTDECONS      VARCHAR(1),
   @P_IDTIPOCONS      VARCHAR(1),
   @P_DTCONSSERV      DATETIME,
   @P_NRLISTA         VARCHAR(10),
   @P_NRLISTAFILISERV VARCHAR(10),
   @P_SOBREPOR        VARCHAR(1)
AS
   DECLARE @V_SOBREPOR VARCHAR(1);

BEGIN

   SET @V_SOBREPOR = @P_SOBREPOR;
   IF @V_SOBREPOR = 'S' BEGIN
      DELETE 
        FROM CONSSERVPME 
       WHERE CDFILCENTPME = @P_CDFILICENTGRAVA 
         AND IDQTDECONPME = @P_IDQTDECONS 
         AND IDTIPOCONPME = @P_IDTIPOCONSGRAVA 
         AND DTCONSERVPME = @P_DTCONSSERV
         AND CDFILCENTPME+CDFILIAL+CDSERVFILI+IDTIPOCONPME NOT IN (SELECT DISTINCT CDFILCENTPME+LISTA.CDLISTA+IDTIPOCONPME
                                                                     FROM CONSSERVPME, LISTA
                                                                    WHERE CDFILCENTPME = @P_CDFILICENTGRAVA   
                                                                      AND @P_CDFILIORIG = SUBSTRING(LISTA.CDLISTA, 1, 4)
                                                                      AND @P_CDSERVORIG = SUBSTRING(LISTA.CDLISTA, 5, 10)       
                                                                      AND IDQTDECONPME = @P_IDQTDECONS        
                                                                      AND IDTIPOCONPME = @P_IDTIPOCONS
                                                                      AND LISTA.NRLISTA = @P_NRLISTAFILISERV);
   END;      
   BEGIN
      INSERT INTO CONSSERVPME
            (CDFILCENTPME, CDFILIAL, CDSERVFILI, IDQTDECONPME,
             IDTIPOCONPME, DTCONSERVPME, CDPRODUTO, QTCONSERVPME)       
            (SELECT @P_CDFILICENTGRAVA, SUBSTRING(LS.CDLISTA, 1, 4) AS CDFILIAL, SUBSTRING(LS.CDLISTA, 5, 10) AS CDSERVFILI,
                    CS.IDQTDECONPME, @P_IDTIPOCONSGRAVA, @P_DTCONSSERVGRAVA, CS.CDPRODUTO, 
                    CS.QTCONSERVPME
               FROM CONSSERVPME CS, LISTA LP, LISTA LS /*lista com cdfilial concatenado com cdservfili*/
              WHERE (CS.CDFILCENTPME = @P_CDFILICENTORIG) 
                AND (CS.CDFILIAL     = @P_CDFILIORIG)     
                AND (CS.CDSERVFILI   = @P_CDSERVORIG)     
                AND (CS.IDQTDECONPME = @P_IDQTDECONS)     
                AND (CS.IDTIPOCONPME = @P_IDTIPOCONS)     
                AND (CS.DTCONSERVPME = @P_DTCONSSERV)     
                AND (LP.CDLISTA      = CS.CDPRODUTO)      
                AND (LP.NRLISTA      = @P_NRLISTA)
                AND (LS.NRLISTA      = @P_NRLISTAFILISERV)
                AND (CS.CDPRODUTO NOT IN (SELECT CDPRODUTO
                                            FROM CONSSERVPME
                                           WHERE CDFILCENTPME = @P_CDFILICENTGRAVA   
                                             AND CDFILIAL     = SUBSTRING(LS.CDLISTA, 1, 4)
                                             AND CDSERVFILI   = SUBSTRING(LS.CDLISTA, 5, 10)       
                                             AND IDQTDECONPME = @P_IDQTDECONS        
                                             AND IDTIPOCONPME = @P_IDTIPOCONSGRAVA   
                                             AND DTCONSERVPME = @P_DTCONSSERVGRAVA)));                          
   END;
END;   
GO

-- VERSAO --
EXEC ATUVEROBJ 'EXPORTA_CONSUMO','5.03.007';
GO

